std::allocator_traits< _Alloc >(3cxx)

NAME
std::allocator_traits< _Alloc > - Uniform interface to all allocator types.

SYNOPSIS

#include <memory>

Inherited by __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< _Char_alloc_type >, __gnu_cxx::__alloc_traits< _CharT_alloc_type >, __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< _Node_alloc_type >, __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< _Bit_alloc_type >, __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< _Tp_alloc_type >, __gnu_cxx::__alloc_traits< _Map_alloc_type >, __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< _Pair_alloc_type >, __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< _Key_alloc_type >, __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< _Node_allocator >, __gnu_cxx::pointer< _Tp_alloc_type >, __gnu_cxx::__alloc_traits< allocator_type >, __gnu_cxx::other< _Alloc >, __gnu_cxx::other< _Alloc >, __gnu_cxx::other< _Alloc >, __gnu_cxx::other< _Alloc >, __gnu_cxx::other< _Alloc >, __gnu_cxx::other< _Alloc >, __gnu_cxx::__alloc_traits< std::allocator< value_type > >, and __gnu_cxx::__alloc_traits< _Alloc, typename >.

  Public Types

typedef _Alloc allocator_type
The allocator type.
using const_pointer
The allocator's const pointer type.
using const_void_pointer
The allocator's const void pointer type.
using difference_type
The allocator's difference type.
using is_always_equal
Whether all instances of the allocator type compare equal.
using pointer
The allocator's pointer type.
using propagate_on_container_copy_assignment
How the allocator is propagated on copy assignment.
using propagate_on_container_move_assignment
How the allocator is propagated on move assignment.
using propagate_on_container_swap
How the allocator is propagated on swap.
template<typename _Tp> using rebind_alloc
template<typename _Tp> using rebind_traits
using size_type
The allocator's size type.
typedef _Alloc::value_type value_type
The allocated type.
using void_pointer
The allocator's void pointer type.

  Static Public Member Functions

static constexpr pointer allocate (_Alloc &__a, size_type __n)
Allocate memory.
static constexpr pointer allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
Allocate memory.
template<typename _Tp, typename... _Args> static constexpr auto construct (_Alloc &__a, _Tp *__p, _Args &&... __args) noexcept(noexcept(_S_construct(__a, __p, std::forward< _Args >(__args)...))) -> decltype(_S_construct(__a, __p, std::forward< _Args >(__args)...))
Construct an object of type _Tp.
static constexpr void deallocate (_Alloc &__a, pointer __p, size_type __n)
Deallocate memory.
template<typename _Tp> static constexpr void destroy (_Alloc &__a, _Tp *__p) noexcept(noexcept(_S_destroy(__a, __p, 0)))
Destroy an object of type _Tp.
static constexpr size_type max_size (const _Alloc &__a) noexcept
The maximum supported allocation size.
static constexpr _Alloc select_on_container_copy_construction (const _Alloc &__rhs)
Obtain an allocator to use when copying a container.

Detailed Description

  template<typename _Alloc>
struct std::allocator_traits< _Alloc >"Uniform interface to all allocator types.

Since
    C++11

Member Typedef Documentation

  template<typename _Alloc> typedef _Alloc std::allocator_traits< _Alloc >::allocator_type

The allocator type.

  template<typename _Alloc> using std::allocator_traits< _Alloc >::const_pointer

The allocator's const pointer type. Alloc::const_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<const value_type>

  template<typename _Alloc> using std::allocator_traits< _Alloc >::const_void_pointer

The allocator's const void pointer type. Alloc::const_void_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<const void>

  template<typename _Alloc> using std::allocator_traits< _Alloc >::difference_type

The allocator's difference type. Alloc::difference_type if that type exists, otherwise pointer_traits<pointer>::difference_type

  template<typename _Alloc> using std::allocator_traits< _Alloc >::is_always_equal

Whether all instances of the allocator type compare equal. Alloc::is_always_equal if that type exists, otherwise is_empty<Alloc>::type

  template<typename _Alloc> using std::allocator_traits< _Alloc >::pointer

The allocator's pointer type. Alloc::pointer if that type exists, otherwise value_type*

  template<typename _Alloc> using std::allocator_traits< _Alloc >::propagate_on_container_copy_assignment

How the allocator is propagated on copy assignment. Alloc::propagate_on_container_copy_assignment if that type exists, otherwise false_type

  template<typename _Alloc> using std::allocator_traits< _Alloc >::propagate_on_container_move_assignment

How the allocator is propagated on move assignment. Alloc::propagate_on_container_move_assignment if that type exists, otherwise false_type

  template<typename _Alloc> using std::allocator_traits< _Alloc >::propagate_on_container_swap

How the allocator is propagated on swap. Alloc::propagate_on_container_swap if that type exists, otherwise false_type

  template<typename _Alloc> using std::allocator_traits< _Alloc >::size_type

The allocator's size type. Alloc::size_type if that type exists, otherwise make_unsigned<difference_type>::type

  template<typename _Alloc> typedef _Alloc::value_type std::allocator_traits< _Alloc >::value_type

The allocated type.

  template<typename _Alloc> using std::allocator_traits< _Alloc >::void_pointer

The allocator's void pointer type. Alloc::void_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<void>

Member Function Documentation

  template<typename _Alloc> constexpr pointer std::allocator_traits< _Alloc >::allocate (_Alloc & __a, size_type __n) [inline], [static], [nodiscard], [constexpr]

Allocate memory.

Parameters
    __a An allocator.
    __n The number of objects to allocate space for.

Calls a.allocate(n)

  template<typename _Alloc> constexpr pointer std::allocator_traits< _Alloc >::allocate (_Alloc & __a, size_type __n, const_void_pointer __hint) [inline], [static], [nodiscard], [constexpr]

Allocate memory.

Parameters
    __a An allocator.
    __n The number of objects to allocate space for.
    __hint Aid to locality.

Returns
    Memory of suitable size and alignment for n objects of type value_type

Returns a.allocate(n, hint) if that expression is well-formed, otherwise returns a.allocate(n)

  template<typename _Alloc> template<typename _Tp, typename... _Args> constexpr auto std::allocator_traits< _Alloc >::construct (_Alloc & __a, _Tp * __p, _Args &&... __args)->decltype(_S_construct(__a, __p, std::forward< _Args >(__args)...)) [inline], [static], [constexpr], [noexcept]

Construct an object of type _Tp.

Parameters
    __a An allocator.
    __p Pointer to memory of suitable size and alignment for Tp
    __args Constructor arguments.

Calls __a.construct(__p, std::forward<Args>(__args)...) if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

  template<typename _Alloc> constexpr void std::allocator_traits< _Alloc >::deallocate (_Alloc & __a, pointer __p, size_type __n) [inline], [static], [constexpr]

Deallocate memory.

Parameters
    __a An allocator.
    __p Pointer to the memory to deallocate.
    __n The number of objects space was allocated for.

Calls a.deallocate(p, n)

  template<typename _Alloc> template<typename _Tp> constexpr void std::allocator_traits< _Alloc >::destroy (_Alloc & __a, _Tp * __p) [inline], [static], [constexpr], [noexcept]

Destroy an object of type _Tp.

Parameters
    __a An allocator.
    __p Pointer to the object to destroy

Calls __a.destroy(__p) if that expression is well-formed, otherwise calls __p->~_Tp()

  template<typename _Alloc> constexpr size_type std::allocator_traits< _Alloc >::max_size (const _Alloc & __a) [inline], [static], [constexpr], [noexcept]

The maximum supported allocation size.

Parameters
    __a An allocator.

Returns
    __a.max_size() or numeric_limits<size_type>::max()

Returns __a.max_size() if that expression is well-formed, otherwise returns numeric_limits<size_type>::max()

  template<typename _Alloc> constexpr _Alloc std::allocator_traits< _Alloc >::select_on_container_copy_construction (const _Alloc & __rhs) [inline], [static], [constexpr]

Obtain an allocator to use when copying a container.

Parameters
    __rhs An allocator.

Returns
    __rhs.select_on_container_copy_construction() or __rhs

Returns __rhs.select_on_container_copy_construction() if that expression is well-formed, otherwise returns __rhs

Author

Generated automatically by Doxygen for libstdc++ from the source code.